/********************************** (C) COPYRIGHT *******************************
 * File Name          : Main.c
 * Author             : WCH
 * Version            : V1.0
 * Date               : 2020/08/06
 * Description        : ʱ
 *********************************************************************************
 * Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
 * Attention: This software (modified or not) and binary are used for 
 * microcontroller manufactured by Nanjing Qinheng Microelectronics.
 *******************************************************************************/

#include "CH57x_common.h"
#include  "core_portme.h"

__attribute__((aligned(4))) uint32_t CapBuf[100];
__attribute__((aligned(4))) uint32_t PwmBuf[100];

volatile uint8_t capFlag = 0;

/*********************************************************************
 * @fn      DebugInit
 *
 * @brief   Գʼ
 *
 * @return  none
 */
void DebugInit(void)
{
    GPIOA_SetBits(GPIO_Pin_9);
    GPIOA_ModeCfg(GPIO_Pin_8, GPIO_ModeIN_PU);
    GPIOA_ModeCfg(GPIO_Pin_9, GPIO_ModeOut_PP_5mA);
    UART1_DefInit();
}

/*********************************************************************
 * @fn      main
 *
 * @brief   
 *
 * @return  none
 */
void init_main(void)
{
    uint8_t i;

    SetSysClock(CLK_SOURCE_PLL_60MHz);

    /* ôڵ */
    DebugInit();
    printf("Start @ChipID=%02X\n", R8_CHIP_ID);
    printf("SysClock = %dHZ\n", GetSysClock());

#if 1 /* ʱ0趨100msʱIOƣ PB15-LED */

    GPIOB_SetBits(GPIO_Pin_15);
    GPIOB_ModeCfg(GPIO_Pin_15, GPIO_ModeOut_PP_5mA);

    TMR0_TimerInit(FREQ_SYS / 1000);       // öʱʱ 1ms
    TMR0_ITCfg(ENABLE, TMR0_3_IT_CYC_END); // ж
    PFIC_EnableIRQ(TMR0_IRQn);
    //TMR0_Enable();
    //TMR0_Disable();
#endif


    while(0)
    {
      ;
    }
}

/*********************************************************************
 * @fn      TMR0_IRQHandler
 *
 * @brief   TMR0жϺ
 *
 * @return  none
 */
__attribute__((interrupt("WCH-Interrupt-fast")))
__attribute__((section(".highcode")))
void TMR0_IRQHandler(void) // TMR0 ʱж
{
    if(TMR0_GetITFlag(TMR0_3_IT_CYC_END))
    {
        TMR0_ClearITFlag(TMR0_3_IT_CYC_END); // жϱ־
        //GPIOB_InverseBits(GPIO_Pin_15);
        Tick++;
    }
}

